import java.util.ArrayList;
import java.io.*;
import java.util.zip.*;
//org.apache.tools.zip.ZipOutputStreamg΃GR[hw肪ł
public class PankuzuZipper{
	boolean cancelPressed = false;
	javax.swing.JLabel progressLabel = null;
	String progressString = "";
	public void cancelReactivate(){
		cancelPressed = false;
	}
	public void zipAllFiles(String outfilename,ArrayList<String> al){
		ArrayList<ZipEntryCassette> fall = new ArrayList<ZipEntryCassette>();
		for(int ii = 0;ii < al.size();ii++){
			fall.addAll(getAllFiles(new File(al.get(ii)),""));
		}
		ArrayList<String> entry = new ArrayList<String>();
		ArrayList<File> file = new ArrayList<File>();
		for(int ii = 0;ii < fall.size();ii++){
			ZipEntryCassette ze = fall.get(ii);
			file.add(ze.file);
			entry.add(ze.entryName);
			
		}
		
		zip(outfilename,file,entry);
		
	}
	public static ArrayList<ZipEntryCassette> getAllFiles(File f,String basecode){
		ArrayList<ZipEntryCassette> ret = new ArrayList<ZipEntryCassette>();
		if(f.exists()){
			if(f.isFile()){
				ret.add(new ZipEntryCassette(f,basecode+f.getName()));
			}else if (f.isDirectory()){
				System.out.println(f.getName());
				File[] flist = f.listFiles();
				int num = 0;
				for(int ii = 0;ii < flist.length;ii++){
					if(!f.getName().equals("..") && !f.getName().equals(".")){
						ret.addAll(getAllFiles(flist[ii],basecode+f.getName()+"/"));
						num++;
					}
				}
				if(num == 0){
					ret.add(new ZipEntryCassette(f,basecode+f.getName()+"/"));
				}
			}
			
		}else{
			System.out.println(f.getPath()+" does not exist.");
		}
		return ret;
	}
	public String getProgressString(){
		return progressString;
	}
	public void setProgressLabel(javax.swing.JLabel jl){
		progressLabel = jl;
	}
	public void cancel(){
		cancelPressed = true;
	}
	public void reactivateCancel(){
		cancelPressed = false;
	}
	public void setProgressString(String px){
		if(progressLabel != null){
			progressLabel.setText(px);
			progressLabel.repaint();
		}
		progressString = px;
	}
	public void zip(String outfilename,ArrayList<File> farray,ArrayList<String> entryarray) {

		File zip =  new File(outfilename);
		
		try {
		    ZipOutputStream out = new ZipOutputStream(new FileOutputStream(zip));
			
			for(int ii = 0;ii < farray.size();ii++){
				String en;
				if(cancelPressed){
					out.close();
					return;
				}
				File f = farray.get(ii);
					if(ii >= entryarray.size()){
						en = String.valueOf(ii)+f.getName();
					}else{
						en = entryarray.get(ii);
					}
			    	appendFile(out,f,en);

			}
			out.close();
		} catch (Exception exx) {
		    exx.printStackTrace();
		}
	}
	public static void appendFile(ZipOutputStream out, File file,String entryname) {
	
		BufferedInputStream  bi = null;
		try {
			if(file.exists()){
				if(file.isFile()){
					
					bi = new BufferedInputStream(new FileInputStream(file));
					ZipEntry ze = new ZipEntry(entryname);
					out.putNextEntry(ze);
					int siz = 0;
					while ((siz = bi.available()) > 0) {
						byte[] bs = new byte[siz];
						bi.read(bs);
						out.write(bs);
					}
					out.closeEntry();
					bi.close();
				}else if(file.isDirectory()){
					String en = entryname;
					if(entryname.indexOf("/") != entryname.length()){
						en = entryname+"/";
					}
					out.putNextEntry(new ZipEntry(en));
					out.closeEntry();
				}
			}else{
				System.out.println(file.getPath()+" does not exist.");
			}
		}catch(Exception exx){
			exx.printStackTrace();
		}
	
	}
	
	
	public static void main(String[] args){
	//	ArrayList<String> fal = new ArrayList<String>();
	//	fal.add("image");
	//	fal.add("Test2.class");
	//	zipAllFiles("test.zip",fal);
	}
}

class ZipEntryCassette{
	File file;
	String entryName;
	ZipEntryCassette(File f,String e){
		file = f;
		entryName = e;
	}
}
