import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public class AuthorDataPanel extends JPanel implements ActionListener,KeyListener{
	//public static final int DATA_TITLE = 0;
	public static final int DATA_NAME = 0;
	public static final int DATA_WEBSITENAME = 1;
	public static final int DATA_WEBSITE = 2;
	public static final int DATA_PUBLISHER = 3;
	public static final int DATA_PUBLISHERWEBSITE = 4;
	
	
	int labelWidth = 120;
	int fieldWidth = 150;
	AuthorData authorData = new AuthorData();
	//String[] dataLabel = {"Title","Name","WebsiteName","WebsiteAddress","Publisher","Publisher website"};
	String[] dataLabel = {"Name","WebsiteName","WebsiteAddress","Publisher","Publisher website"};
	JLabel jLabel[];
	JPanel dataPanel[];
	JTextField dataField[];
	
	JButton okButton = new JButton("OK");
	JButton cancelButton = new JButton("CANCEL");
	
	String title = "";
	AuthorDataPanel(){
		jLabel = new JLabel[dataLabel.length];
		dataPanel = new JPanel[dataLabel.length];
		dataField = new JTextField[dataLabel.length];
		JPanel paneltop = new JPanel();
		GridLayout gl = new GridLayout(dataPanel.length,1);
		//gl.setHgap(0);
		//gl.setVgap(2);
		paneltop.setLayout(gl);
		for(int ii = 0;ii < dataLabel.length;ii++){
			jLabel[ii] = new JLabel(dataLabel[ii]);
			jLabel[ii].setPreferredSize(new Dimension(labelWidth,12));
			dataField[ii] = new JTextField(12);
			dataField[ii].setPreferredSize(new Dimension(fieldWidth,21));
			dataPanel[ii] = new JPanel();
			dataPanel[ii].setLayout(new FlowLayout(FlowLayout.LEFT,2,0));
			dataPanel[ii].add(jLabel[ii]);
			dataPanel[ii].add(dataField[ii]);
			paneltop.add(dataPanel[ii]);
			dataField[ii].addKeyListener(this);
		
		}
		this.add(paneltop);
		
		
		JPanel panelbottom = new JPanel();
		panelbottom.setLayout(new FlowLayout(FlowLayout.RIGHT,3,0));
		JPanel buttonpanel  = new JPanel();
		GridLayout gl2 = new GridLayout(1,2);
		buttonpanel.setLayout(gl2);
		gl2.setHgap(2);
		buttonpanel.add(okButton);
		buttonpanel.add(cancelButton);
		okButton.setMargin(new Insets(2,5,2,5));
		cancelButton.setMargin(new Insets(2,5,2,5));
		
		panelbottom.add(buttonpanel);
		this.add(panelbottom);
		this.setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		javax.swing.border.EmptyBorder margin = new javax.swing.border.EmptyBorder(5,5,5,5);
		this.setBorder(margin);
		
		okButton.addActionListener(this);
		cancelButton.addActionListener(this);
		
	}
	public static void main(String args[]){
		JFrame jf = new JFrame("test");
		AuthorDataPanel adp = new AuthorDataPanel();
		jf.add(adp);
		jf.pack();
		jf.setVisible(true);
		AuthorData ad = new AuthorData();
		ad.setAuthorName("TEST");
		adp.setAuthorData(ad);
	}
	public AuthorData getAuthorData(){
		return authorData;
	}
	
	public void copyAuthorData(AuthorData ad){
		AuthorData tmp = authorData;
		setAuthorData(ad);
		authorData = tmp;
		okPressed();
	}
	public void setAuthorData(AuthorData ad){
		authorData = ad;
		dataField[DATA_NAME].setText(ad.getAuthorName());
		dataField[DATA_WEBSITE].setText(ad.getAuthorWebsite());
		dataField[DATA_WEBSITENAME].setText(ad.getAuthorWebsiteName());
		dataField[DATA_PUBLISHER].setText(ad.getPublisherName());
		dataField[DATA_PUBLISHERWEBSITE].setText(ad.getPublisherWebsite());
	}
	public void saveAuthorData(String filename){
		try{
			
		}catch(Exception exx){
			exx.printStackTrace();
		}
	}
	public void setTitle(String t){
		title = t;
	}
	public String getTitle(){
		return title;
	}
	public void okPressed(){
		//setTitle(dataField[DATA_TITLE].getText());
		authorData.setAuthorName(dataField[DATA_NAME].getText());
		authorData.setAuthorWebsite(dataField[DATA_WEBSITE].getText());
		authorData.setAuthorWebsiteName(dataField[DATA_WEBSITENAME].getText());
		authorData.setPublisherName(dataField[DATA_PUBLISHER].getText());
		authorData.setPublisherWebsite(dataField[DATA_PUBLISHERWEBSITE].getText());
	}
	public void actionPerformed(ActionEvent e){
		if(e.getSource() == okButton){
			okPressed();
		}else if(e.getSource() == cancelButton){
			setAuthorData(authorData);
		//	dataField[DATA_TITLE].setText(getTitle());
		}
	}
	public void keyTyped(KeyEvent e){
		if(e.getKeyCode() == KeyEvent.VK_ENTER){
			okButton.doClick();
		}else if(e.getKeyCode() == KeyEvent.VK_ESCAPE){
			cancelButton.doClick();
		}
		
	}
	public void keyPressed(KeyEvent e){
		
	}
	public void keyReleased(KeyEvent e){
		
	}
}
