import java.awt.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import java.io.*;
import javax.swing.*;
import javax.swing.tree.*;
import java.awt.event.*;
import java.util.*;
import java.util.regex.*;
public class PPMainPanel extends JPanel implements ActionListener,MouseListener,WindowListener,KeyListener{
	
	public static final String[] INTERPRETATIONSTRING = {"INSERTNODE","DELETENODE","SELECTIONCHANGED","NEWNODE","UPDATENODE","SETCURRENTDIR"};
	public static final int TREE_INSERTNODE = 0;
	public static final int TREE_DELETENODE = 1;
	public static final int TREE_SELECTIONCHANGED = 2;
	public static final int TREE_APPENDNEWNODE = 3;
	public static final int TREE_UPDATENODE = 4;
	public static final int EVENTCODE_SETCURRENTDIR = 5;
	public static final int EVENTCODE_COMPILE = 6;
	public static final int COMPILE_NORMALZIP = 7;
	public static final int COMPILE_ANDROBOOKZIP = 8;
	public static final int COMPILE_PDF = 9;
	public static final int COMPILE_EPUB = 10;
	public static final int EVENTCODE_SETAUTHORDATA = 11;
	public static final int EVENTCODE_CLEAR = 12;
	//-------------------------------------------------܂育Ƃ-------------//
	public static final int EVENT_COPY = 0;
	public static final int EVENT_PASTE = 1;
	public static final int EVENT_DELETE = 2;
	public static final int EVENT_NEW = 3;
	public static final int EVENT_COMPILE = 4;
	public static final int EVENT_DOWN = 5;
	public static final int EVENT_CUT = 6;
	public static final int EVENT_CHANGENAME = 7;
	public static final int EVENT_MARGE = 8;
	public static final int EVENT_HIDEWITHINSERTNODE = 9;
	public static final int EVENT_HIDECANCELLED= 10;
	public static final int EVENT_UNDO = 11;
	public static final int EVENT_REDO = 12;
	public static final int EVENT_SELECTALL = 13;
	public static final int EVENT_RUNCOMPILE = 14;
	public static final int EVENT_SHOWPROPERTY = 15;
	public static final int EVENT_NEWFILE = 16;
	public static final int EVENT_LOAD = 17;
	public static final int EVENT_SAVE = 18;
	public static final int EVENT_SHOWPREVIEW = 19;
	public static final int EVENT_GROUP = 20;
	public static final int EVENT_SHOWAUTHORPANEL = 21;
	public static final int EVENT_CANCELCOMPILE = 22;
	public static final int EVENT_SETAUTHORDATA = 23;
	public static final int EVENT_REVERTAUTHORDATA = 24;
	public static final int EVENT_UPDATENODE = 25;
	
	
	public static final int SEPARATOR = -1;
	
	public static final int JPANEL_BASE = 0;
	public static final int JPANEL_MAIN = 1;
	public static final int JPANEL_BUTTON = 2;
	public static final int[] JPANEL__GROUP = {-1,0,-1};
	
	
	public static final int JBUTTON_ADD = 0;
	public static final int JBUTTON_DELETE = 1;
	public static final int JBUTTON_CUT = 2;
	public static final int JBUTTON_COPY = 3;
	public static final int JBUTTON_PASTE = 4;
	public static final int JBUTTON_REV = 5;
	public static final int JBUTTON_CANCELCOMPILE = 6;
	public static final String[] JBUTTON__NAME = {"NEW","DEL","CUT","COPY","PASTE","COMPILE","CANCEL"};
	public static final int[] JBUTTON__EVENT ={EVENT_NEW,EVENT_DELETE,EVENT_CUT,EVENT_COPY,EVENT_PASTE,EVENT_COMPILE,EVENT_CANCELCOMPILE};
	public static final int[] JBUTTON__GROUP ={JPANEL_BUTTON,JPANEL_BUTTON,JPANEL_BUTTON,JPANEL_BUTTON,JPANEL_BUTTON,JPANEL_BUTTON,-1};
	
	
	public static final int JPOPUPMENU_EDIT = 0;
	public static final String[] JPOPUPMENU__NAME = {"edit"};
	public static final int[] JPOPUPMENU__EVENT ={-1};
	
	
	public static final int JRADIOBUTTONMENUITEM_DUMMY = 0;
	public static final String[] JRADIOBUTTONMENUITEM__NAME = {};
	public static final int[] JRADIOBUTTONMENUITEM__GROUP = {};
	public static final int[] JRADIOBUTTONMENUITEM__EVENT ={};
	
	public static final int JMENUITEMPOP_CUT = 0;
	public static final int JMENUITEMPOP_COPY = 1;
	public static final int JMENUITEMPOP_PASTE = 2;
	public static final int JMENUITEMPOP_DELETE = 3;
	public static final int JMENUITEMPOP_SEP1 = 4;
	public static final int JMENUITEMPOP_GROUP = 5;
	public static final int JMENUITEMPOP_SELECTALL = 6;
	public static final int JMENUITEMPOP_SEP2 = 7;
	public static final int JMENUITEMPOP_CHANGENAME = 8;
	public static final int JMENUITEMPOP_SEP3 = 9;
	public static final String[] JMENUITEMPOP__NAME = {"Cut","Copy","Paste","Delete","sep"
														,"Group","Select All","sep","Property","sep"};
	public static final int[] JMENUITEMPOP__GROUP = {JPOPUPMENU_EDIT,JPOPUPMENU_EDIT,JPOPUPMENU_EDIT,JPOPUPMENU_EDIT,JPOPUPMENU_EDIT
													,JPOPUPMENU_EDIT,JPOPUPMENU_EDIT,JPOPUPMENU_EDIT,JPOPUPMENU_EDIT,JPOPUPMENU_EDIT,JPOPUPMENU_EDIT};
	public static final int[] JMENUITEMPOP__EVENT ={EVENT_CUT,EVENT_COPY,EVENT_PASTE,EVENT_DELETE,-1
													,EVENT_GROUP,EVENT_SELECTALL,-1,EVENT_SHOWPROPERTY,-1};
	
	public static final int JMENU_FILE = 0;
	public static final int JMENU_EDIT = 1;
	public static final int JMENU_VIEW = 2;
	public static final String[] JMENU__NAME = {"File","Edit","Window"};
	public static final int[] JMENU__EVENT ={-1,-1,-1};
	
	
	public static final int JMENUITEM_NEWFILE = 0;
	public static final int JMENUITEM_LOAD = 1;
	public static final int JMENUITEM_SAVE = 2;
	public static final int JMENUITEM_AUTHOR = 3;
	public static final int JMENUITEM_UNDO = 4;
	public static final int JMENUITEM_REDO = 5;
	public static final int JMENUITEM_SEP1 = 6;
	public static final int JMENUITEM_NEW = 7;
	public static final int JMENUITEM_CUT = 8;
	public static final int JMENUITEM_COPY = 9;
	public static final int JMENUITEM_PASTE = 10;
	public static final int JMENUITEM_DELETE = 11;
	public static final int JMENUITEM_SEP2 = 12;
	public static final int JMENUITEM_GROUP = 13;
	public static final int JMENUITEM_SELECTALL = 14;
	public static final int JMENUITEM_SEP3 = 15;
	public static final int JMENUITEM_PROPERTY = 16;
	public static final int JMENUITEM_PREVIEW = 17;
	
	
	
	public static final String[] JMENUITEM__NAME = {"New","Load","Save","AuthorData"
												,"Undo","Redo","sep","New","Cut","Copy","Paste","Delete","sep","Group","Select All","sep","Property"
												,"Preview"};
	public static final int[] JMENUITEM__GROUP = {JMENU_FILE,JMENU_FILE,JMENU_FILE,JMENU_VIEW
												,JMENU_EDIT,JMENU_EDIT,JMENU_EDIT,JMENU_EDIT,JMENU_EDIT,JMENU_EDIT,JMENU_EDIT,JMENU_EDIT,JMENU_EDIT,JMENU_EDIT,JMENU_EDIT,JMENU_EDIT,JMENU_EDIT
												,JMENU_VIEW};
	public static final int[] JMENUITEM__EVENT ={EVENT_NEWFILE,EVENT_LOAD,EVENT_SAVE,EVENT_SHOWAUTHORPANEL,
												EVENT_UNDO,EVENT_REDO,-1,EVENT_NEW,EVENT_CUT,EVENT_COPY,EVENT_PASTE,EVENT_DELETE,-1,EVENT_GROUP,EVENT_SELECTALL,-1
												,EVENT_SHOWPROPERTY,EVENT_SHOWPREVIEW};
	
	
	
	
	
	JMenu[] jMenu;
	JMenuBar jMenuBar = new JMenuBar();
	JMenuItem[] jMenuItem;
	JMenuItem[] jMenuItemPop;
	JPanel[] jPanel;
	JButton[] jButton;
	JRadioButtonMenuItem[] jRadioButtonMenuItem;
	
	StringBuffer errorBuff = new StringBuffer();
	JPopupMenu[] jPopupMenu;
	Hashtable<Object,Integer> eventObjectHash = new Hashtable<Object,Integer>();
	double mouseRealX = 0;
	double mouseRealY = 0;
	public void setAllPanels(){
		
		jMenu = new JMenu[JMENU__NAME.length];
		for(int ii = 0;ii < JMENU__NAME.length;ii++){
			jMenu[ii] = new JMenu(JMENU__NAME[ii]);
			if(JMENU__EVENT[ii] > -1){
				eventObjectHash.put(jMenu[ii],JMENU__EVENT[ii]);
			}
			jMenuBar.add(jMenu[ii]);
		}
		
		jMenuItem = new JMenuItem[JMENUITEM__NAME.length];
		for(int ii = 0;ii < JMENUITEM__NAME.length;ii++){
			if(JMENUITEM__NAME[ii].compareTo("sep") != 0){ 
				jMenuItem[ii] = new JMenuItem(JMENUITEM__NAME[ii]);
				if(JMENUITEM__GROUP[ii] > -1){
					jMenu[JMENUITEM__GROUP[ii]].add(jMenuItem[ii]);
				}
				jMenuItem[ii].addActionListener(this);
				if(JMENUITEM__EVENT[ii] > -1){
					eventObjectHash.put(jMenuItem[ii],JMENUITEM__EVENT[ii]);
				}
			}else{
				jMenu[JMENUITEM__GROUP[ii]].addSeparator();
			}
		}
		
		
		jPopupMenu = new JPopupMenu[JPOPUPMENU__NAME.length];
		for(int ii = 0;ii < JPOPUPMENU__NAME.length;ii++){
			jPopupMenu[ii] = new JPopupMenu(JPOPUPMENU__NAME[ii]);
			if(JPOPUPMENU__EVENT[ii] > -1){
				eventObjectHash.put(jPopupMenu[ii],JPOPUPMENU__EVENT[ii]);
			}
		}
		jMenuItemPop = new JMenuItem[JMENUITEMPOP__NAME.length];
		for(int ii = 0;ii < JMENUITEMPOP__NAME.length;ii++){
			if(JMENUITEMPOP__NAME[ii].compareTo("sep") != 0){ 
				jMenuItemPop[ii] = new JMenuItem(JMENUITEMPOP__NAME[ii]);
				if(JMENUITEMPOP__GROUP[ii] > -1){
					jPopupMenu[JMENUITEMPOP__GROUP[ii]].add(jMenuItemPop[ii]);
				}
				jMenuItemPop[ii].addActionListener(this);
				if(JMENUITEMPOP__EVENT[ii] > -1){
					eventObjectHash.put(jMenuItemPop[ii],JMENUITEMPOP__EVENT[ii]);
				}
			}else{
				jPopupMenu[JMENUITEMPOP__GROUP[ii]].addSeparator();
			}
		}
		
		jPanel = new JPanel[JPANEL__GROUP.length];
		for(int ii = 0;ii < JPANEL__GROUP.length;ii++){
			jPanel[ii] = new JPanel();
			if(JPANEL__GROUP[ii] > -1){
				jPanel[JPANEL__GROUP[ii]].add(jPanel[ii]);
			}
		}
		jButton = new JButton[JBUTTON__NAME.length];
		for(int ii = 0;ii < JBUTTON__NAME.length;ii++){
			jButton[ii] = new JButton(JBUTTON__NAME[ii]);
			jButton[ii].setMargin(new Insets(0,0,0,0));
			if(JBUTTON__GROUP[ii] > -1){
				jPanel[JBUTTON__GROUP[ii]].add(jButton[ii]);
			}
			if(JBUTTON__EVENT[ii] > -1){
				jButton[ii].addActionListener(this);
				eventObjectHash.put(jButton[ii],JBUTTON__EVENT[ii]);
			}
		}
		
		/*
		Hashtable<Integer,ButtonGroup> buttonhash = new Hashtable<Integer,ButtonGroup>();
		jRadioButtonMenuItem = new JRadioButtonMenuItem[JRADIOBUTTONMENUITEM__NAME.length];
		
		for(int ii = 0;ii < JRADIOBUTTONMENUITEM__NAME.length;ii++){
			jRadioButtonMenuItem[ii] = new JRadioButtonMenuItem(JRADIOBUTTONMENUITEM__NAME[ii]);
			if(JRADIOBUTTONMENUITEM__GROUP[ii] > -1){
				if(buttonhash.get(JRADIOBUTTONMENUITEM__GROUP[ii]) == null){
					ButtonGroup bg = new ButtonGroup();
					bg.add(jRadioButtonMenuItem[ii]);
					buttonhash.put(JRADIOBUTTONMENUITEM__GROUP[ii],bg);
				}else{
					buttonhash.get(JRADIOBUTTONMENUITEM__GROUP[ii]).add(jRadioButtonMenuItem[ii]);
				}
				jMenu[JRADIOBUTTONMENUITEM__GROUP[ii]].add(jRadioButtonMenuItem[ii]);
			}
			if(JRADIOBUTTONMENUITEM__EVENT[ii] > -1){
				jRadioButtonMenuItem[ii].addActionListener(this);
				eventObjectHash.put(jRadioButtonMenuItem[ii],JRADIOBUTTONMENUITEM__EVENT[ii]);
			}
		}
		*/
		
	}
	//-------------------------------------------------܂育Ƃ܂------------------------------------------------------//
	
	public static String SEPARATER_A = ">";
	public static String SEPARATER_B = "<";
	PagePropertyDialog pagePropertyDialog;
	JDialog compilerDialog;
	PPLayerTree tree;
	
	Hashtable<String,Integer> eventStringHash = new Hashtable<String,Integer>();
	Hashtable<String,Integer> actionCodeHash = new Hashtable<String,Integer>();
    JFrame parentFrame;
	BinderPopup binderPopup = new BinderPopup(eventObjectHash);
	String currentDir = "./";
	PankuzuCompilerPanel compilerPanel = new PankuzuCompilerPanel();
	ImagePreviewPanel previewPanel = new ImagePreviewPanel();
	JFrame previewFrame = new JFrame("Preview");
	JFrame authorFrame = new JFrame("AuthorData");
	JFrame progressFrame = new JFrame("Progress");
	String clipBoard = "";
	Hashtable<String,String> imageExtension = new Hashtable<String,String>();
	PPLayerTree historyTree;
	int historyLimit = 30;
	int currentHistoryPos = 0;
	ArrayList<String> historyList = new ArrayList<String>();
	AuthorDataPanel authorDataPanel = new AuthorDataPanel();
	JTextField titleField = new JTextField(24);
	JCheckBox r2LBox = new JCheckBox("direction: L<-R");
	JCheckBox twoUpBox = new JCheckBox("TwoUp");
	JLabel progressLabel = new JLabel("progress");
	Thread vThread;
	AuthorData authorData = new AuthorData();
	
	PankuzuCompilerPanel zipCompiler = null;
	SimplePDFCompiler pdfCompiler = null;
	EPubCompiler epubCompiler = null;
	String targetDir = "";
	public PPMainPanel() {
		this(null);
    }
	public PPMainPanel(JFrame f) {
        super(new BorderLayout());
		setAllPanels();
		
		
		jMenuItem[JMENUITEM_NEWFILE].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,InputEvent.CTRL_MASK));
		jMenuItem[JMENUITEM_LOAD].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L,InputEvent.CTRL_MASK));
		jMenuItem[JMENUITEM_SAVE].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,InputEvent.CTRL_MASK));
		jMenuItem[JMENUITEM_UNDO].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,InputEvent.CTRL_MASK));
		jMenuItem[JMENUITEM_REDO].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Y,InputEvent.CTRL_MASK));
		jMenuItem[JMENUITEM_NEW].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_U,InputEvent.CTRL_MASK));
		jMenuItem[JMENUITEM_DELETE].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_DELETE,0));
		jMenuItem[JMENUITEM_CUT].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,InputEvent.CTRL_MASK));
		jMenuItem[JMENUITEM_COPY].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,InputEvent.CTRL_MASK));
		jMenuItem[JMENUITEM_PASTE].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V,InputEvent.CTRL_MASK));
		jMenuItem[JMENUITEM_PROPERTY].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E,InputEvent.CTRL_MASK));
		jMenuItem[JMENUITEM_PREVIEW].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,InputEvent.CTRL_MASK));
		jMenuItem[JMENUITEM_SELECTALL].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A,InputEvent.CTRL_MASK));
		jMenuItem[JMENUITEM_GROUP].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_G,InputEvent.CTRL_MASK));
		
		imageExtension.put("png","png");
		imageExtension.put("gif","gif");
		imageExtension.put("jpeg","jpg");
		imageExtension.put("jpg","jpg");
		imageExtension.put("bmp","bmp");
		compilerPanel.setParentListener(this);
		
		parentFrame = f;
		f.setJMenuBar(jMenuBar);
		pagePropertyDialog = new PagePropertyDialog(f);
		pagePropertyDialog.setCurrentDir(currentDir);
		pagePropertyDialog.propertyPanel.ok.addActionListener(this);
		pagePropertyDialog.propertyPanel.cancel.addActionListener(this);
		
		compilerDialog = new JDialog(f);
		compilerDialog.add(compilerPanel);
		compilerDialog.pack();
		compilerDialog.setTitle("Compile");
		
		compilerDialog.setLocationRelativeTo(null);
		eventObjectHash.put(compilerPanel,EVENT_RUNCOMPILE);
		
		
		eventObjectHash.put(pagePropertyDialog.propertyPanel.ok,EVENT_HIDEWITHINSERTNODE);
		eventObjectHash.put(pagePropertyDialog.propertyPanel.cancel,EVENT_HIDECANCELLED);
		eventObjectHash.put(authorDataPanel.okButton,EVENT_SETAUTHORDATA);
		eventObjectHash.put(authorDataPanel.cancelButton,EVENT_REVERTAUTHORDATA);
		authorDataPanel.okButton.addActionListener(this);
		authorDataPanel.cancelButton.addActionListener(this);
		
		jPanel[JPANEL_BUTTON].setLayout(new GridLayout(2,3));
		
		for(int ii = 0;ii < JBUTTON__NAME.length;ii++){
			jButton[ii].setFont(new Font("Gothic",Font.BOLD,10));
		}
		jPanel[JPANEL_BUTTON].setMaximumSize(new Dimension(1024,48));
		
		
        tree = new PPLayerTree();
        DefaultTreeModel model = makeModel(tree.getNodeHash());
        tree.setModel(model);
		tree.setParentListener(this);
		tree.addMouseListener(this);
		tree.setInputMap(WHEN_FOCUSED,new InputMap());
		
		historyTree = new PPLayerTree();
		DefaultTreeModel tmodel = makeModel(historyTree.getNodeHash());
		historyTree.setModel(tmodel);
		historyTree.copyFrom(tree);
        for(int i=0;i<tree.getRowCount();i++) {
            tree.expandRow(i);
        }
		this.setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		//this.add(jPanel[JPANEL_BASE]);
		JPanel tp = new JPanel();
		JLabel tl = new JLabel("Title:");
		tp.add(tl);
		tp.add(titleField);
		titleField.setText("MyComic");
		SimplePopupForJTextComponent spp = new SimplePopupForJTextComponent(titleField);//Pass the instance at constructor.
		spp.setHistoryMax(100);//Change stock size of undoable events.(default:10)
		spp.setURAccelerator();//Set key accelerator for undo(CTRL+Z) redo(CTRL+SHIFT+Z).
		JPanel toppanel = new JPanel();
		toppanel.setLayout(new GridLayout(2,1));
		JPanel toppanel2 = new JPanel();
		toppanel2.setLayout(new GridLayout(1,2));
		toppanel.add(tp);
		toppanel2.add(twoUpBox);
		//twoUpBox.setSelected(true);
		toppanel2.add(r2LBox);
		r2LBox.setSelected(true);
		toppanel.add(toppanel2);
		
		this.add(toppanel);
        this.add(new JScrollPane(tree), BorderLayout.CENTER);
		this.add(jPanel[JPANEL_BUTTON]);
        setPreferredSize(new Dimension(320, 240));
		PPLayerTree.setInterpretationString(actionCodeHash);
		PankuzuCompilerPanel.setInterpretationString(actionCodeHash);
		actionCodeHash.put("SETAUTHORDATA",EVENTCODE_SETAUTHORDATA);
		actionCodeHash.put("CLEAR",EVENTCODE_CLEAR);
		binderPopup.addActionListener(this);
		
		previewPanel.setPreferredSize(new Dimension(300,400));
		previewFrame.getContentPane().add(previewPanel);
		previewFrame.pack();
		previewFrame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    	
		JPanel pp = new JPanel();
		
		pp.setLayout(new BoxLayout(pp,BoxLayout.Y_AXIS));
		pp.add(progressLabel);
		pp.add(jButton[JBUTTON_CANCELCOMPILE]);
		progressFrame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		progressFrame.getContentPane().add(pp);
		progressFrame.pack();
		authorFrame.getContentPane().add(authorDataPanel);
		authorFrame.pack();
		authorFrame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    }
	public void setParentFrame(JFrame f){
		parentFrame = f;
		
	}
	
	public static String getExtensionCode(File f){
		return getExtensionCode(f.getPath());
	}
	public static String getExtensionCode(String f){
		Pattern pat = Pattern.compile("\\.([^.]+)$");
		Matcher mat = pat.matcher(f);
		if(mat.find()){
			return mat.group(1);
		}
		return "";
	}
    private DefaultTreeModel makeModel(Hashtable<String,LabeledNode> hash) {
		
		String test[] = {"ROOT"};
		for(int ii = 0;ii < test.length;ii++){
			hash.put(test[ii],new LabeledNode(test[ii],test[ii],test[ii].indexOf("element")>-1));
		}
		
		//labelHash.get("SET1").add(labelHash.get("element1"));
		//labelHash.get("SET2").add(labelHash.get("element2"));
		//labelHash.get("SET3").add(labelHash.get("element3"));
        //labelHash.get("ROOT").add(labelHash.get("SET1"));
        //labelHash.get("ROOT").add(labelHash.get("SET2"));
        //labelHash.get("ROOT").add(labelHash.get("SET3"));
        return new DefaultTreeModel(hash.get("ROOT"));
    }

    public static void main(String[] args) {
        EventQueue.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }
    public static void createAndShowGUI() {
        try{
            UIManager.getInstalledLookAndFeels();
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }catch(Exception e) {
            e.printStackTrace();
        }
        final JFrame frame = new JFrame("PiCoPounder");
        //frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		PPMainPanel ppna = new PPMainPanel(frame);
		frame.addWindowListener(ppna);
        frame.getContentPane().add(ppna);
        frame.pack();
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);
		Point p = frame.getLocationOnScreen();
		ppna.previewFrame.setLocation((int)p.getX()-300,(int)p.getY());
		ppna.authorFrame.setLocation((int)p.getX()-300,(int)p.getY());
		ppna.progressFrame.setLocationRelativeTo(null);
        File authorfile = new File("author.dat");
	  if(authorfile.exists()){
	  	ppna.loadAuthorData("author.dat");
	  }else{
		ppna.authorFrame.setVisible(true);
	  }
    }
	
	public void cancel(){
		if(pdfCompiler != null)pdfCompiler.cancel();
		if(zipCompiler != null)zipCompiler.cancel();
		if(epubCompiler != null)epubCompiler.cancel();
	}
	public void copySelected(){
		ArrayList<LabeledNode> al = tree.getSelectedNodes();
		HashSet<Integer> rem = new HashSet<Integer>();
		for(int ii = 0;ii < al.size();ii++){
			if(!rem.contains(ii)){
				for(int jj = 0;jj < al.size();jj++){
					if(jj != ii && al.get(jj).isNodeAncestor(al.get(ii))){
						rem.add(jj);
					}
				}
			}
		}
		ArrayList<LabeledNode> alp = new ArrayList<LabeledNode>();
		
		for(int ii = 0;ii < al.size();ii++){
			if(!rem.contains(ii)){
				alp.add(al.get(ii));
				
			}
		}
		setClipBoard(tree.copyAllNodes(alp,"@@@"));
	}
	
	public void setClipBoard(String str){
		clipBoard = str;
	}
	public void pasteCopied(){
		LabeledNode ln = tree.getNearestGroup();
		String pid = "ROOT";
		if(ln != null){
			pid = ln.getId();
		}
		Hashtable<String,String> nummap = new Hashtable<String,String>();
		String px[] = clipBoard.split(SEPARATER_A);
		StringBuffer code = new StringBuffer();
		for(int ii = 0;ii < px.length;ii++){
			if(px[ii].length() > 1){
				Hashtable<String,String> ht = parseContent(px[ii]);
				if(ht.get("ID") != null){
					String ptx[] = ht.get("ID").split(":::");
					StringBuffer sb = new StringBuffer();
					for(int jj = 0;jj < ptx.length;jj++){
						if(ptx[jj].indexOf("#") == 0){
							if(nummap.get(ptx[jj]) == null){
								String newid = String.valueOf(LabeledNode.createNewId());
								nummap.put(ptx[jj],newid);
								sb.append(newid+":::");
							}else{
								sb.append(nummap.get(ptx[jj])+":::");
							}
						}
					}
					ht.put("ID",sb.toString());
				}
				
				
				if(ht.get("PARENT") != null){
					if(ht.get("PARENT").indexOf("#") == 0){
						if(nummap.get(ht.get("PARENT")) == null){
							String newid = String.valueOf(LabeledNode.createNewId());
							nummap.put(ht.get("PARENT"),newid);
							ht.put("PARENT",newid);
						}else{
							ht.put("PARENT",nummap.get(ht.get("PARENT")));
						}
					}else if(ht.get("PARENT").indexOf("@@@") == 0){
						ht.put("PARENT",pid);
					}
					
				}
				code.append(generateContentString(ht)+SEPARATER_A);
			}
		}
		
		
		
		interpret(code.toString());
	}
	public void actionPerformed(ActionEvent e){
		if(e.getSource() == tree){
			interpret(e.getActionCommand());
		}else{
			if(eventObjectHash.get(e.getSource()) != null){
				switch(eventObjectHash.get(e.getSource())){
					case EVENT_NEWFILE:
					
					interpret(SEPARATER_A+"ACTION=CLEAR"+SEPARATER_B);
					
					break;
					case EVENT_SAVE:
					String ofname = getOutputFilePath("test.ppp");
					if(ofname.length() > 0){
						saveTree(ofname,new StringBuffer(),tree.getNodeHash().get("ROOT"));
					}
					break;
					case EVENT_LOAD:
					loadTree();
					break;
					case EVENT_SHOWPROPERTY:
					{
						ArrayList<LabeledNode> al = tree.getSelectedNodes();
						if( al.size() > 0){
							pagePropertyDialog.updateMode(al.get(0));
						}
					}
					break;
					case EVENT_SETAUTHORDATA:
					{
						authorDataPanel.okPressed();
						AuthorData add = authorDataPanel.getAuthorData();
						StringBuffer sb2 = new StringBuffer();
						//	setAuthorData(action.get("AUTHORNAME"),action.get("AUTHORWEBSITENAME"),
						//	action.get("AUTHORWEBSITEADDRESS"),action.get("PUBLISHERNAME"),action.get("PUBLISHERWEBSITEADDRESS"));
						
						
						
						sb2.append(SEPARATER_A+"ACTION=SETAUTHORDATA"+SEPARATER_B);
						sb2.append("AUTHORNAME="+add.getAuthorName()+SEPARATER_B);
						sb2.append("AUTHORWEBSITENAME="+add.getAuthorWebsiteName()+SEPARATER_B);
						sb2.append("AUTHORWEBSITEADDRESS="+add.getAuthorWebsite()+SEPARATER_B);
						sb2.append("PUBLISHERNAME="+add.getPublisherName()+SEPARATER_B);
						sb2.append("PUBLISHERWEBSITEADDRESS="+add.getPublisherWebsite()+SEPARATER_B);
						interpret(sb2.toString());
						authorFrame.setVisible(false);
					}
					break;
					case EVENT_REVERTAUTHORDATA:
						authorDataPanel.copyAuthorData(authorData);
						authorFrame.setVisible(false);
					break;
					case EVENT_SELECTALL:
					tree.addSelectionInterval(0,tree.getRowCount());
						
					break;
					case EVENT_NEW:
					//pagePropertyDialog.setVisible(true);
					pagePropertyDialog.insertMode();
					break;
					case EVENT_COMPILE:
					compilerDialog.setVisible(true);
					break;
					case EVENT_RUNCOMPILE:
					interpret(e.getActionCommand(),tree,false);
					break;
					case EVENT_GROUP:{
						ArrayList<LabeledNode> al = tree.getSelectedNodes();
						if( al.size() > 0){
							StringBuffer sb = new StringBuffer();
							sb.append(SEPARATER_A+"ACTION="+PPLayerTree.INTERPRETATIONSTRING[PPLayerTree.TREE_APPENDNEWNODE]+SEPARATER_B);
							
							int groupid = LabeledNode.createNewId();
							sb.append("DATA=GROUP=newgroup"+SEPARATER_B);
							sb.append("ID=");
							sb.append(groupid);
							sb.append(SEPARATER_B);
							sb.append("PARENT="+((LabeledNode)al.get(0).getParent()).getId()+SEPARATER_B);
							sb.append("POS="+al.get(0).getParent().getIndex(al.get(0))+SEPARATER_B);
							
							interpret(sb.toString());
							HashSet<LabeledNode> rem = new HashSet<LabeledNode>();
							for(int ii = 0;ii < al.size();ii++){
								LabeledNode na = al.get(ii);
								if(!rem.contains(na)){
									for(int jj = ii+1;jj < al.size();jj++){
										LabeledNode pa = al.get(jj);
										if(na.isNodeDescendant(pa)){
											rem.add(pa);
										}
									}
								}
							}
							
							StringBuffer sb2 = new StringBuffer();
							for(int ii = al.size()-1;ii >= 0 ;ii--){
								LabeledNode na = al.get(ii);
								if(!rem.contains(na)){
									sb2.append(SEPARATER_A+"ACTION="+PPLayerTree.INTERPRETATIONSTRING[PPLayerTree.TREE_INSERTNODE]+SEPARATER_B);
									sb2.append("ID=");
							
									sb2.append(na.getId());
									sb2.append(SEPARATER_B+"PARENT="+groupid+SEPARATER_B+"POS=0");
								}
							}
							interpret(sb2.toString());
							
						}
					}
					break;
					case EVENT_SHOWPREVIEW:
					previewFrame.setVisible(true);
					break;
					case EVENT_SHOWAUTHORPANEL:
					authorFrame.setVisible(true);
					break;
					case EVENT_COPY:
					copySelected();
					break;
					
					case EVENT_CANCELCOMPILE:
					
					cancel();
					break;
					
					case EVENT_CUT:
					copySelected();
					deleteSelected();
					break;
					
					case EVENT_PASTE:
					if(clipBoard.length()>0){
						pasteCopied();
					}
					break;
					case EVENT_UNDO:
					undo();
					reloadModel();
					break;
					case EVENT_REDO:
					redo();
					reloadModel();
					break;
					
					
					case EVENT_HIDEWITHINSERTNODE://OK_PRESSED
					
					{
						String res = pagePropertyDialog.getPropertyString();
						if(res.indexOf("UPDATE")==0){
							String sgg[] = res.split(":::");
							StringBuffer sb = new StringBuffer();
							sb.append(SEPARATER_A+"ACTION="+PPLayerTree.INTERPRETATIONSTRING[PPLayerTree.TREE_UPDATENODE]+SEPARATER_B);
							sb.append("ID="+sgg[1]+SEPARATER_B);
							sb.append("LABEL="+sgg[2]+SEPARATER_B);
							interpret(sb.toString());
						}else{
						
							
							StringBuffer sb = new StringBuffer();
							sb.append(SEPARATER_A+"ACTION="+PPLayerTree.INTERPRETATIONSTRING[PPLayerTree.TREE_APPENDNEWNODE]+SEPARATER_B);
							
							boolean groupflag = false;
							String groupid = "";
							if(res.indexOf("GROUP=") == 0){
								groupflag = true;
								
							}
							sb.append("DATA="+res+SEPARATER_B);
							String sgg[] = res.split(":::");
							sb.append("ID=");
							for(int kkk = 0;kkk < sgg.length;kkk++){
								int pid = LabeledNode.createNewId();
								sb.append(pid);
								if(groupflag){
									groupid = String.valueOf(pid);
								}
								sb.append(":::");
							}
							sb.append(SEPARATER_B);
							
							
							TreePath pd[] = tree.getSelectionPaths();
							String parentlabel;
							if(pd != null){
								TreePath tp = pd[pd.length-1];
								LabeledNode ld = (LabeledNode)tree.getNearestGroupNode(tp);
								if(ld == null){
									parentlabel = "ROOT";
								}else{
									parentlabel = ld.getId();
								}
							}else{
								parentlabel = "ROOT";
							}
							sb.append("PARENT="+parentlabel+SEPARATER_B);
							ArrayList<LabeledNode> al = tree.getSelectedNodes();
							if(!groupflag && al.size() > 0){
								int pos = tree.getNodeHash().get(parentlabel).getIndex(al.get(0))+1;
								sb.append("POS="+pos+SEPARATER_B);
			
							}
							interpret(sb.toString());
							
							if(groupflag && al.size() > 0){
								
								HashSet<LabeledNode> rem = new HashSet<LabeledNode>();
								for(int ii = 0;ii < al.size();ii++){
									LabeledNode na = al.get(ii);
									if(!rem.contains(na)){
										for(int jj = ii+1;jj < al.size();jj++){
											LabeledNode pa = al.get(jj);
											if(na.isNodeDescendant(pa)){
												rem.add(pa);
											}
										}
									}
								}
								
								StringBuffer sb2 = new StringBuffer();
								for(int ii = al.size()-1;ii >= 0 ;ii--){
									LabeledNode na = al.get(ii);
									if(!rem.contains(na)){
										sb2.append(SEPARATER_A+"ACTION="+PPLayerTree.INTERPRETATIONSTRING[PPLayerTree.TREE_INSERTNODE]+SEPARATER_B);
										sb2.append("ID=");
								
										sb2.append(na.getId());
										sb2.append(SEPARATER_B+"PARENT="+groupid+SEPARATER_B+"POS=0");
									}
								}
								interpret(sb2.toString());
								
							}
							
						}
					}
					pagePropertyDialog.setVisible(false);
					break;
					
					case EVENT_HIDECANCELLED:
					pagePropertyDialog.setVisible(false);
					break;
					case EVENT_DELETE:{
						deleteSelected();
					}break;
					
				}
				
			}
			
			
		}
		if(ErrorMessageBox.hasMessage()){
			ErrorMessageBox.showDialog(parentFrame);
			ErrorMessageBox.clear();
		}
	}
	public void undo(){
		if(historyList.size() > currentHistoryPos){
			currentHistoryPos ++;
		}
		if(currentHistoryPos > historyLimit){
			currentHistoryPos = historyLimit;
			return;
		}else{
			tree.copyFrom(historyTree);
			for(int ii = 0;ii < historyList.size()-currentHistoryPos;ii++){
				String code = historyList.get(ii);
				interpret(code,tree,false);
			}
		}
	}
	public void redo(){
		if(currentHistoryPos < 1){
			currentHistoryPos = 0;
			return;
		}
		int ii = historyList.size()-currentHistoryPos;
		String code = historyList.get(ii);
		interpret(code,tree,false);
		currentHistoryPos--;
	}
	
	public void keyPressed(KeyEvent e){
		/*int keycode = e.getKeyCode();
		int mod = e.getModifiersEx();
		
		if (keycode == KeyEvent.VK_UP && (mod & InputEvent.SHIFT_DOWN_MASK) != 0){
			
		}*/
		
	}
	public void keyTyped(KeyEvent e){
		
	}
	public void keyReleased(KeyEvent e){
		

	}
	
	public void deleteSelected(){
		String res = "";
		StringBuffer sb = new StringBuffer();
		sb.append(SEPARATER_A+"ACTION="+PPLayerTree.INTERPRETATIONSTRING[PPLayerTree.TREE_DELETENODE]+SEPARATER_B);
		ArrayList<LabeledNode> al = tree.getSelectedNodes();
		if(al.size() > 0){
			sb.append("ID=");
			for(int ii = 0;ii < al.size();ii++){
				sb.append(al.get(ii).getId()+":::");
				getAllChildren(al.get(ii));
			}
			interpret(sb.toString());
		}
	}
	public String getOutputFilePath(String fname){
		
		JFileChooser filechooser = new JFileChooser(currentDir);
		filechooser.setSelectedFile(new File(fname));
		int selected = filechooser.showSaveDialog(this);
		while(selected == JFileChooser.APPROVE_OPTION){
			File file = filechooser.getSelectedFile();
			if(file.exists()){
					int res = JOptionPane.showConfirmDialog(null,"The file already exists.\nOverwrite?","NOTICE",
					JOptionPane.YES_NO_OPTION,JOptionPane.INFORMATION_MESSAGE);
					if(res == JOptionPane.YES_OPTION){
						return file.getPath();
					}
					
			}else{
				return file.getPath();
			}
			 selected = filechooser.showSaveDialog(this);
		}
		return "";
		
	}
	public String pathStructureString(LabeledNode rootnode){
		ArrayList<LabeledNode> al = getAllChildren(rootnode);
		Hashtable<String,String> oldtonew = new Hashtable<String,String>();
		StringBuffer ret = new StringBuffer();
		ret.append(SEPARATER_A+"ACTION="+PPLayerTree.INTERPRETATIONSTRING[PPLayerTree.TREE_APPENDNEWNODE]+SEPARATER_B);
		ret.append("DATA=");
		StringBuffer idsb = new StringBuffer();
		idsb.append("ID=");
		oldtonew.put("ROOT","ROOT");
		for(int ii = 0;ii < al.size();ii++){
			LabeledNode lb = al.get(ii);
			oldtonew.put(lb.getId(),"ID"+String.valueOf(ii));
			ret.append(lb.getCreationCode()+":::");
			idsb.append("ID"+String.valueOf(ii)+":::");
		}
		ret.append(SEPARATER_B);
		ret.append(idsb);
		ret.append(SEPARATER_A+"\n");
		
		for(int ii = 0;ii < al.size();ii++){
			LabeledNode ln = al.get(ii);
			LabeledNode pn = (LabeledNode)ln.getParent();
			ret.append(SEPARATER_A+"ACTION="+INTERPRETATIONSTRING[TREE_INSERTNODE]+SEPARATER_B);
			ret.append("ID="+oldtonew.get(ln.getId())+SEPARATER_B);
			ret.append("PARENT="+oldtonew.get(pn.getId())+SEPARATER_B);
			ret.append("POS="+pn.getIndex(ln)+SEPARATER_B);
			
			ret.append(SEPARATER_A+"\n");
		
			//model.insertNodeInto(ln,targetnode,targetnode.getChildCount());
		}
		
		return ret.toString();
	
	}
	public void loadTree(){
		loadTree(tree);
	}
	public void loadTree(PPLayerTree targettree){
		try{
			Hashtable<String,LabeledNode> targethash = targettree.getNodeHash();
			JFileChooser filechooser = new JFileChooser(currentDir);
			int selected = filechooser.showOpenDialog(this);
			String filename = null;
			while(selected == JFileChooser.APPROVE_OPTION){
				File file = filechooser.getSelectedFile();
				if(file.exists()){
					filename = file.getPath();
					break;
				}else{
					JOptionPane.showMessageDialog(this,"File does not exist.");
				}
				 selected = filechooser.showOpenDialog(this);
			}
			
			if(filename == null){
				return;
			}
			File in = new File(filename);
			BufferedReader br = new BufferedReader(new FileReader(new File(filename)));
			setCurrentDir(in.getParent());
			String str = "";
			boolean interpretflag = false;
			StringBuffer sb = new StringBuffer();
			while((str = br.readLine()) != null){
				if(str.indexOf("#PATH_STRUCTURE_FORMAT_1")==0){
					interpretflag = true;
				}else{
					if(interpretflag){
						sb.append(str);
					}
				}
			}
			br.close();
			
			targettree.addSelectionInterval(0,targettree.getRowCount());
			//targettree.deleteSelected();
			LabeledNode lr = targethash.get("ROOT");
			if(lr != null){
				lr.removeAllChildren();
				targethash.clear();
				targethash.put("ROOT",lr);
			}else{
				targethash.put("ROOT",new LabeledNode("ROOT","ROOT",false));
			}
			((DefaultTreeModel)targettree.getModel()).reload();
			interpret(sb.toString());
			((DefaultTreeModel)targettree.getModel()).reload();
		}catch(Exception exx){
			exx.printStackTrace();
			
		}
	}
	public void setCurrentDir(String f){
		currentDir = f;
	}
	public void saveTree(String filename,StringBuffer authorinfo,LabeledNode rootnode){
		try{
			File out = new File(filename);
			OutputStreamWriter fw = new OutputStreamWriter(new FileOutputStream(out),"UTF-8");
			BufferedWriter br = new BufferedWriter(fw);
			br.write(authorinfo.toString());
			
			br.write("\n#PATH_STRUCTURE_FORMAT_1\n");
			br.write(pathStructureString(rootnode));
			br.close();
			
			
		}catch(Exception exx){
			exx.printStackTrace();
			
		}
	}
	public void interpret(String s){
		interpret(s,tree,true);
	}
	
	public void interpret(String s,PPLayerTree targettree){
		interpret(s,targettree,true);
	}
	
	public static Hashtable<String,StringBuffer> getMappedData(String filename){
		try{
			BufferedReader br = new BufferedReader(new FileReader(new File(filename)));
			String ln = null;
			Pattern pat = Pattern.compile("^#([^\\s]+)");
			Hashtable<String,StringBuffer> ret = new Hashtable<String,StringBuffer>();
			StringBuffer sb = null;
			while((ln = br.readLine()) != null){
				Matcher mat = pat.matcher(ln);
				if(mat.find()){
					 sb = new StringBuffer();
					String lab = mat.group(1);
					ret.put(lab,sb);
				}else if(sb != null){
					sb.append(ln);
				}
				
			}
			br.close();
			return ret;
		}catch(Exception exx){
			exx.printStackTrace();
			
		}
		return null;
		
	}
	public void loadAuthorData(String str){
		Hashtable<String,String> action = SimpleDataParser.loadSharpBlock(str);
		setAuthorData(action.get("AUTHOR"),action.get("AUTHOR_WEBSITENAME"),
		action.get("AUTHOR_WEBSITEADDRESS"),action.get("PUBLISHER"),action.get("PUBLISHER_WEBSITEADDRESS"));
		if(action.get("TWO_UP") != null){
			try{
				if(Integer.parseInt(action.get("TWO_UP")) > 0){
					twoUpBox.setSelected(true);
				}else{
					twoUpBox.setSelected(false);
				}
			}catch(Exception exx){
				exx.printStackTrace();
			}
		}
		if(action.get("R2L") != null){
			try{
				if(Integer.parseInt(action.get("R2L")) > 0){
					r2LBox.setSelected(true);
				}else{
					r2LBox.setSelected(false);
				}
			}catch(Exception exx){
				exx.printStackTrace();
			}
		}
		
		authorDataPanel.copyAuthorData(authorData);
	}
	public void saveAuthorData(){
		
		
		try{
			BufferedWriter bw = new BufferedWriter(new FileWriter(new File("author.dat")));
			bw.write("#AUTHOR\n");
			bw.write(authorData.getAuthorName()+"\n");
			bw.write("#AUTHOR_WEBSITENAME\n");
			bw.write(authorData.getAuthorWebsiteName()+"\n");
			bw.write("#AUTHOR_WEBSITEADDRESS\n");
			bw.write(authorData.getAuthorWebsite()+"\n");
			bw.write("#PUBLISHER\n");
			bw.write(authorData.getPublisherName()+"\n");
			bw.write("#PUBLISHER_WEBSITEADDRESS\n");
			bw.write(authorData.getPublisherWebsite()+"\n");
			bw.write("#R2L\n");
			bw.write(((r2LBox.isSelected())?("1\n"):("0\n")));
			bw.write("#TWO_UP\n");
			bw.write(((twoUpBox.isSelected())?("1\n"):("0\n")));
			
			
			bw.close();
		}catch(Exception exx){
			exx.printStackTrace();
		}
	}
	public void setAuthorData(String aname,String awebsite,String aadress,String pname,String pwebsite){
		authorData.setAuthorName(aname);
		authorData.setAuthorWebsiteName(awebsite);
		authorData.setAuthorWebsite(aadress);
		authorData.setPublisherName(pname);
		authorData.setPublisherWebsite(pwebsite);
		saveAuthorData();
		//System.out.println(aname+";"+awebsite+";"+aadress+";"+pname+";"+pwebsite);
	}
	public void interpret(String s,PPLayerTree targettree,boolean recordflag){
		//System.out.println(s);
		
		if(targettree == tree && recordflag && s.indexOf("!") != 0){
			for(int ii = 0;ii < currentHistoryPos;ii++){
				historyList.remove(historyList.size()-1);
			}
			currentHistoryPos = 0;
			historyList.add(s);
			if(historyList.size() > historyLimit){
				String code = historyList.get(0);
				interpret(code,historyTree);
				historyList.remove(0);
			}
		}
		Hashtable<String,LabeledNode> targethash = targettree.getNodeHash();
		DefaultTreeModel model = (DefaultTreeModel)targettree.getModel();
		String[] str1 = s.split(SEPARATER_A);
		for(int ii = 0;ii < str1.length;ii++){
			//System.out.println(str1[ii]);
			if(str1[ii].length() > 2){
				Hashtable<String,String> action = parseContent(str1[ii]);
				String Ids[] = null;
				String data[] = null;
				if(action.get("ID") != null){
					Ids = action.get("ID").split(":::");
				}
				if(action.get("PARENT") == null || (action.get("PARENT") != null && targethash.get(action.get("PARENT")) == null)){
					action.put("PARENT","ROOT");	
				}
				if(action.get("DATA") != null){
					data = action.get("DATA").split(":::");
				}
				if(actionCodeHash.get(action.get("ACTION")) != null){
					
					switch(actionCodeHash.get(action.get("ACTION"))){
						case EVENTCODE_COMPILE:{
							int type = Integer.parseInt(action.get("TYPE"));
							compile(type);
							
						}break;
						case EVENTCODE_SETCURRENTDIR:{
							setCurrentDir(action.get("DIR"));
							
						}break;
						case TREE_UPDATENODE:{
							targethash.get(action.get("ID")).updateLabel(action.get("LABEL"));
						
						}break;
						case EVENTCODE_SETAUTHORDATA:{
							setAuthorData(action.get("AUTHORNAME"),action.get("AUTHORWEBSITENAME"),
							action.get("AUTHORWEBSITEADDRESS"),action.get("PUBLISHERNAME"),action.get("PUBLISHERWEBSITEADDRESS"));
							
						
						}break;
						case TREE_SELECTIONCHANGED:
						if(Ids.length >=1){
							LabeledNode lb = targethash.get(Ids[0]);
							if(lb != null && lb.type == LabeledNode.TYPE_FILE){
								File ff= new File(lb.label);
								//System.out.println(lb.label);
								if(ff.exists()){
									previewPanel.setImage(ff);
								}
							}
						}
						
						break;
						
						case TREE_APPENDNEWNODE:{
							int pos = targethash.get(action.get("PARENT")).getChildCount();
							if(action.get("POS") != null){
								pos = Integer.parseInt(action.get("POS"));
							}
							for(int jj = 0;jj < data.length;jj++){
								LabeledNode newnode = new LabeledNode(Ids[jj],data[jj],data[jj].indexOf("FILEPATH") >-1);
								String id = newnode.getId();
								targethash.put(id,newnode);
								model.insertNodeInto(targethash.get(id),targethash.get(action.get("PARENT")),pos);
								targettree.expandPath(new TreePath(((LabeledNode)newnode.getParent()).getPath()));
		
							}
							
							reloadModel();
						}break;
						case TREE_INSERTNODE:{
							int pos = targethash.get(action.get("PARENT")).getChildCount();
							if(action.get("POS") != null){
								pos = Integer.parseInt(action.get("POS"));
							}
							for(int jj = 0;jj < Ids.length;jj++){
								
								if(targethash.get(Ids[jj]) == null){
									LabeledNode newnode = new LabeledNode(Ids[jj],Ids[jj],Ids[jj].indexOf("FILEPATH") >-1);
									String id = newnode.getId();
									targethash.put(id,newnode);
								}
								if(action.get("POS") == null){
									pos = targethash.get(action.get("PARENT")).getChildCount();
								}
								model.insertNodeInto(targethash.get(Ids[jj]),targethash.get(action.get("PARENT")),pos);
								//model.reload();
							}
							reloadModel();
							
						}break;
						case EVENTCODE_CLEAR:{
							ArrayList<LabeledNode> al = getAllChildren(targethash.get("ROOT"));
							for(int kk = 0;kk < al.size();kk++){
								targethash.remove(al.get(kk));
								model.removeNodeFromParent(al.get(kk));

							}
							reloadModel();
						}break;
						case TREE_DELETENODE:{
							if(action.get("ID") != null){
								for(int jj = 0;jj < Ids.length;jj++){
									if(targethash.get(Ids[jj]) != null){
										model.removeNodeFromParent(targethash.get(Ids[jj]));
										ArrayList<LabeledNode> al = getAllChildren(targethash.get(Ids[jj]));
										targethash.remove(Ids[jj]);
										for(int kk = 0;kk < al.size();kk++){
											targethash.remove(al.get(kk));
										}
									}
								}
							}
							reloadModel();
						}break;
					}
				}
			}
		}
	}
	public void reloadModel(){
		reloadModel(tree);
		
	}
	public void reloadModel(PPLayerTree targettree){
		if(targettree.getPathForRow(0) == null)return;
		Enumeration enu = targettree.getExpandedDescendants(targettree.getPathForRow(0).getParentPath());
		((DefaultTreeModel)(targettree.getModel())).reload();
		if(enu == null){
		}else{
			while(enu.hasMoreElements()){
				targettree.expandPath((TreePath)enu.nextElement());
			}
		}
	}
	public void compile(int type){
		//System.out.println("----------");
		switch(type){
			case COMPILE_NORMALZIP:{
				String fname = "comic.zip";
				if(titleField.getText().length() > 0){
					fname = titleField.getText()+".zip";
				}
				final String filename = getOutputFilePath(fname);
				if(filename.length() > 0){
					//System.out.println(filename);
					ArrayList<NodeWithRoute> al  = getAllChildrenWithRoute(tree.getNodeHash().get("ROOT"),"");
					final ArrayList<File> post = new ArrayList<File>();
					final ArrayList<String> entry = new ArrayList<String>();
					Hashtable<String,String> posted = new Hashtable<String,String>();
					for(int ii = 0;ii < al.size();ii++){
						NodeWithRoute ln = al.get(ii);
						
						if(ln.node.type == LabeledNode.TYPE_FILE){
							File ff = new File(ln.node.label);
							post.add(ff);
							if(posted.get(ln.route+ff.getName()) == null){
								
								entry.add(ln.route+ff.getName());
								
								posted.put(ln.route+ff.getName(),"1");
							}else{
								int ppt = 0;
								String fnamen = ln.route+ppt+"_"+ff.getName();
								while(posted.get(fnamen) != null){
									fnamen = ln.route+ppt+"_"+ff.getName();
									ppt++;
								}
								entry.add(fnamen);
								posted.put(fnamen,"1");
								errorBuff.append("Duplicated entry name was changed. "+ln.route+ff.getName()+">"+fnamen+"\n");
							}
						}
					}
					if(post.size() > 0){
						
						if(vThread == null || !vThread.isAlive()){
							vThread = new Thread() {
						        public void start() {
						           super.start();
						        }
								public void run(){
									PankuzuCompilerPanel pc = new PankuzuCompilerPanel();
									zipCompiler = pc;
									progressFrame.setVisible(true);
									
									pc.setProgressLabel(progressLabel);
									pc.zip(filename,post,entry);
									progressFrame.setVisible(false);
									checkErrorMessage();
								}
							};
							vThread.start();
						}
					}
				}
			}break;
			case COMPILE_ANDROBOOKZIP:
			{	
				String fname = "comic.zip";
				if(titleField.getText().length() > 0){
					fname = titleField.getText()+".zip";
				}
				final String filename = getOutputFilePath(fname);
				if(filename.length() > 0){
					//System.out.println(filename);
					ArrayList<LabeledNode> al  = getAllChildren(tree.getNodeHash().get("ROOT"));
					final ArrayList<File> post = new ArrayList<File>();
					for(int ii = 0;ii < al.size();ii++){
						LabeledNode ln = al.get(ii);
						if(ln.type == LabeledNode.TYPE_FILE){
							File pf = new File(ln.label);
							if(pf.exists()){
								if(isImageFile(ln.label)){
									post.add(pf);
								}else{
									errorBuff.append(ln.label+" was not compiled. Only jpg, png, bmp, gif were allowed.\n");
							
								}
							}else{
								errorBuff.append(ln.label+" was not found.\n");
								
							}
						}
					}
					if(post.size() > 0){
						if(vThread == null || !vThread.isAlive()){
							vThread = new Thread() {
						        public void start() {
						           super.start();
						        }
								public void run(){
									PankuzuCompilerPanel pc = new PankuzuCompilerPanel();
									zipCompiler = pc;
									progressFrame.setVisible(true);
									
									pc.setProgressLabel(progressLabel);
									pc.makeAndroBookZip(filename,post);
									progressFrame.setVisible(false);
									checkErrorMessage();
								}
							};
							vThread.start();
						}
					}
				}
			}
			break;
			case COMPILE_PDF:
			{
				final SimplePDFCompiler sp = new SimplePDFCompiler();
				sp.setR2LFlag(r2LBox.isSelected());
				String fname = "comic.pdf";
				if(titleField.getText().length() > 0){
					fname = titleField.getText()+".pdf";
				}
				final String filename = getOutputFilePath(fname);
				if(filename.length() > 0){
					//authorData.setTitle(titleField.getText());
					ArrayList<LabeledNode> al  = getAllChildren(tree.getNodeHash().get("ROOT"));
					ArrayList<File> post = new ArrayList<File>();
					Hashtable<Object,PDFBookMarkNode> pagenode = new Hashtable<Object,PDFBookMarkNode>();
					ArrayList<PDFBookMarkNode> bookmarkbuff = new ArrayList<PDFBookMarkNode>();
					if(twoUpBox.isSelected()){
						//sp.setTwoUpFlag(true);
					}
					
					
					for(int ii = 0;ii < al.size();ii++){
						LabeledNode ln = al.get(ii);
						if(ln.type == LabeledNode.TYPE_FILE){
							File pf = new File(ln.label);
							if(pf.exists()){
								
							
								if(isImageFile(ln.label)){
									
									try{
										PDFPageObject pa =  sp.addFittedImage(ln.label);
										if(bookmarkbuff.size() != 0){
											for(int jj = 0;jj < bookmarkbuff.size();jj++){
												bookmarkbuff.get(jj).setPage(pa);
											}
											bookmarkbuff.clear();
										}
									}catch(Exception exx){
										exx.printStackTrace();
									}
								}else{
										
									errorBuff.append(ln.label+" was not compiled. Only jpg, png, bmp, gif were allowed.\n");
								}
							}else{
								errorBuff.append(ln.label+" was not found.\n");
								
							}
							
						}else if(ln.type == LabeledNode.TYPE_GROUP){
							PDFBookMarkNode cc = sp.addBookMark(ln.label,null);
							if(ln.getParent()!=null){
								if(pagenode.get(ln.getParent()) != null){
									pagenode.get(ln.getParent()).addChildNode(cc);
								}
							}
							bookmarkbuff.add(cc);
							pagenode.put((Object)ln,cc);
						}else if(ln.type == LabeledNode.TYPE_BOOKMARK){
							PDFBookMarkNode cc = sp.addBookMark(ln.label,null);
							if(ln.getParent()!=null){
								if(pagenode.get(ln.getParent()) != null){
									pagenode.get(ln.getParent()).addChildNode(cc);
								}
							}
							bookmarkbuff.add(cc);
						}
					}
					
							if(vThread == null || !vThread.isAlive()){
								vThread = new Thread() {
							        public void start() {
							           super.start();
							        }
									public void run(){
										progressFrame.setVisible(true);
										pdfCompiler = sp;
										sp.setProgressLabel(progressLabel);
										sp.drawAuthorData(authorData);
										sp.setAuthor(authorData.getAuthorName());
										sp.setTitle(titleField.getText());
										sp.generatePDF(filename);
										progressFrame.setVisible(false);
										checkErrorMessage();
									}
								};
								vThread.start();
							}
				}
			}
			
			break;
			case COMPILE_EPUB:{
				
				String fname = "comic.epub";
				if(titleField.getText().length() > 0){
					fname = titleField.getText()+".epub";
				}
				final String filename = getOutputFilePath(fname);
				if(filename.length() > 0){
					final EPubContent ep = new EPubContent();
					//authorData.setTitle(titleField.getText());
					ep.setAuthorData(authorData);
					ep.setTitle(titleField.getText());
					if(twoUpBox.isSelected()){
						//ep.addBlankPage();
						//ep.setTwoUpFlag(true);
					}
					if(r2LBox.isSelected()){
						ep.setRtLFlag(true);
					}
					ArrayList<LabeledNode> al  = getAllChildren(tree.getNodeHash().get("ROOT"));
					ArrayList<File> post = new ArrayList<File>();
					ArrayList<String> bookmarkbuff = new ArrayList<String>();
					int pcou = 1;
					XHTMLComicPage currentpage = null;
					for(int ii = 0;ii < al.size();ii++){
						LabeledNode ln = al.get(ii);
						if(ln.type == LabeledNode.TYPE_FILE){
							File pf = new File(ln.label);
							if(pf.exists()){
								
								if(isImageFile(ln.label)){
									boolean newpageflag = false;
									if(currentpage == null){
									
										XHTMLComicPage cp = new XHTMLComicPage("page"+pcou,new File(ln.label));
										ep.addContentsPage(cp);
										pcou++;
										for(int jj = 0;jj < bookmarkbuff.size();jj++){
											ep.addIndex(cp,bookmarkbuff.get(jj));
										}
										bookmarkbuff.clear();
										if(!twoUpBox.isSelected()){
											currentpage = null;
										}else{
											currentpage = cp;
										}
									}else{
										currentpage.addNewImage(new File(ln.label));
										pcou++;
										for(int jj = 0;jj < bookmarkbuff.size();jj++){
											ep.addIndex(currentpage,bookmarkbuff.get(jj),currentpage.getPageNum()-1);
										}
										bookmarkbuff.clear();
										currentpage= null;
									}
								}else{
									
									errorBuff.append(ln.label+" was not compiled. Only jpg, png, bmp, gif were allowed.\n");
								}
							}else{
								errorBuff.append(ln.label+" was not found.\n");
								
							}
						}else if(ln.type == LabeledNode.TYPE_GROUP){
							bookmarkbuff.add(ln.label);
						}else if(ln.type == LabeledNode.TYPE_BOOKMARK){
							bookmarkbuff.add(ln.label);
						}
					}
					ep.addAuthorInfoPage();
							
					if(vThread == null || !vThread.isAlive()){
						vThread = new Thread() {
					        public void start() {
					           super.start();
					        }
							public void run(){
									progressFrame.setVisible(true);
								EPubCompiler ec = new EPubCompiler();
								epubCompiler = ec;
								ec.setProgressLabel(progressLabel);
								ec.compile(filename,ep);
								epubCompiler = null;
								progressFrame.setVisible(false);
								checkErrorMessage();
							}
						};
						vThread.start();
					}
				}
			}
			break;
		}
	}
	public boolean isImageFile(String str){
		String ext = getExtensionCode(str).toLowerCase();
		if(imageExtension.get(ext) != null){
			return true;
		}else{
			return false;
		}
	}
	public ArrayList<LabeledNode> getAllChildren(LabeledNode l){
		ArrayList<LabeledNode> ret =  new  ArrayList<LabeledNode>();
		Enumeration enu = l.children();
		while(enu.hasMoreElements()){
			LabeledNode dt = (LabeledNode)enu.nextElement();
			ret.add(dt);
			if(dt.getChildCount() != 0){
				ret.addAll( getAllChildren(dt));
			}
		}
		return ret;
	}
	public void checkErrorMessage(){
		ErrorMessageBox.append(errorBuff.toString());
		if(ErrorMessageBox.hasMessage()){
			ErrorMessageBox.showDialog(parentFrame);
			ErrorMessageBox.clear();
			errorBuff = new StringBuffer();
		}
	}
	public ArrayList<NodeWithRoute> getAllChildrenWithRoute(LabeledNode l,String route){
		ArrayList<NodeWithRoute> ret =  new  ArrayList<NodeWithRoute>();
		Enumeration enu = l.children();
		while(enu.hasMoreElements()){
			LabeledNode dt = (LabeledNode)enu.nextElement();
			ret.add(new NodeWithRoute(dt,route));
			
			if(dt.getChildCount() != 0){
				String gname = dt.label.replaceFirst("[\\s]*GROUP[\\s]*=[\\s]*","");
				
				ret.addAll( getAllChildrenWithRoute(dt,route+gname+"/"));
			}
		}
		return ret;
	}
	public String generateContentString(Hashtable<String,String> ht){//Hashtable疽ߕ
		Enumeration<String> enu = ht.keys();
		StringBuffer ret = new StringBuffer();
		while(enu.hasMoreElements()){
			String kk = enu.nextElement();
			ret.append(kk+"=");
			ret.append(ht.get(kk)+SEPARATER_B);
		}
		return ret.toString();
	}
	
	
	public Hashtable<String,String> parseContent(String str){//ߕHashtable
		String ar[] = str.split(SEPARATER_B);
		Pattern pat = Pattern.compile("([^=]+)=(.*)");
		Hashtable<String,String> ret = new Hashtable<String,String>();
		for(int ii = 0;ii < ar.length;ii++){
			Matcher mat = pat.matcher(ar[ii]);
			if(mat.find()){
				String k = mat.group(1).toUpperCase();
				String v = mat.group(2);
				//System.out.println(k+"*"+v);
				ret.put(k,v);
			}
		}
		return ret;
	}
	public void mousePressed(MouseEvent e){
		if (e.isMetaDown()) {
			binderPopup.show(e.getComponent(), e.getX(), e.getY());
		}
	}
	public void mouseReleased(MouseEvent e){
	   
	}    
	public void mouseClicked(MouseEvent e){
		
	}
	public void mouseEntered(MouseEvent e){
	}        
	public void mouseExited(MouseEvent e){
	}
	public  void windowActivated(WindowEvent e){}
	public  void windowClosed(WindowEvent e){
	}
	public  void windowClosing(WindowEvent e){
		saveAuthorData();
		parentFrame.dispose();
		previewFrame.dispose();
		authorFrame.dispose();
		progressFrame.dispose();
	}
	public  void windowDeactivated(WindowEvent e){}
	public  void windowDeiconified(WindowEvent e){}
	public  void windowIconified(WindowEvent e){}
	public  void windowOpened(WindowEvent e) {}
}
class NodeWithRoute{
	LabeledNode node;
	String route;
	NodeWithRoute(LabeledNode l,String r){
		route = r;
		node = l;
	}
}
class LabeledNode extends DefaultMutableTreeNode{
	public static final int TYPE_FILE = 0;
	public static final int TYPE_BOOKMARK = 1;
	public static final int TYPE_GROUP = 2;
	public static final int TYPE_ROOT = 4;
	
	String label;
	String desc;
	String creationCode = "";
	int type = TYPE_FILE;
	static int currentId = 0;
	boolean leafLabelFlag = false;
	String id = "0";
	public static Integer createNewId(){
		return currentId++;
	}
	public void copyFrom(LabeledNode ln,boolean copychild){
		label = ln.label;
		desc = ln.desc;
		creationCode = ln.creationCode;
		type = ln.type;
		leafLabelFlag = ln.leafLabelFlag;
		id = ln.id;
		this.removeAllChildren();
		if(copychild){
			int cou = ln.getChildCount();
			if(cou > 0){
				for(int jj = 0;jj < cou;jj++){
					LabeledNode lb = (LabeledNode)ln.getChildAt(jj);
					LabeledNode newln = new LabeledNode("dummy");
					this.add(newln);
					newln.copyFrom(lb,true);
				}
			}
			
		}
	}
	public static ArrayList<Integer> createNewId(int num){
		ArrayList<Integer> ret = new ArrayList<Integer>();
		for(int ii = 0;ii < num;ii++){
			ret.add(currentId++);
			
		}
		return ret;
	}
	
	
	public String getId(){
		return id;
	}
	public void setId(String i){
		id = i;
	}
	LabeledNode(String dummy){
		super(dummy);
	}
	LabeledNode(Object o,String l,boolean leaf){
		this(o,l,l,leaf);
	}
	LabeledNode(Object o,String l,String d,int t,boolean leaf){
		super(o);
		id = o.toString();
		label = l;
		desc = d;
		type = t;
		leafLabelFlag = leaf;
	}
	
	LabeledNode(Object o,String l,String d,boolean leaf){
		super(o);
		id = o.toString();
		label = l;
		
		desc = d;
		creationCode = l;
		if(d.indexOf("FILEPATH") == 0){
			label = label.replace("FILEPATH=","");
			File f = new File(label);
			desc = f.getName();
			
			type = TYPE_FILE;
		}
		if(d.indexOf("GROUP") == 0){
			label = label.replace("GROUP=","");
			desc = label;
			type = TYPE_GROUP;
		}
		if(d.indexOf("BOOKMARK") == 0){
			label = label.replace("BOOKMARK=","");
			desc = label;
			type = TYPE_BOOKMARK;
		}
		leafLabelFlag = leaf;
	}
	public void setLeafLabelFlag(boolean b){
		leafLabelFlag = b;
	}
	public boolean isLeafLabel(){
		return leafLabelFlag;
	}
	public String getLabel(){
		return label;
	}
	public String toString(){
		return desc;
	}
	public String getDesc(){
		return desc;
	}
	public void setDesc(String str){
		desc = str;
	}
	public boolean isGroupNode(){
		return type == TYPE_GROUP;
	}
	public String getCreationCode(){
		switch(type){
			case TYPE_FILE:
			return "FILEPATH="+label;
			case TYPE_BOOKMARK:
			return "BOOKMARK="+label;
			case TYPE_GROUP:
			return "GROUP="+label;
			case TYPE_ROOT:
			return "ROOTNODE";
		}
		return "";
	}
	
	public void updateLabel(String s){
		desc = s;
		label=s;
		switch(type){
			case TYPE_FILE:
			label = label.replace("^FILEPATH=","");
			File f = new File(label);
			desc = f.getName();
			
			type = TYPE_FILE;
			return;
			case TYPE_BOOKMARK:
			label = label.replace("^BOOKMARK=","");
			desc = label;
			type = TYPE_BOOKMARK;
			return;
			case TYPE_GROUP:
			label = label.replace("^GROUP=","");
			desc = label;
			type = TYPE_GROUP;
			return ;
			case TYPE_ROOT:
			return ;
		}
	}
	public void setLabel(String s){
		label = s;
	}
}
class PagePropertyDialog extends JDialog{
	PagePropertyPanel propertyPanel = new PagePropertyPanel();

	PagePropertyDialog() {
		getContentPane().add(propertyPanel);
		setTitle("Property");
	}
	
	PagePropertyDialog(JFrame f) {
		super(f);
		getContentPane().add(propertyPanel);
		setTitle("Property");
		pack();
		setLocationRelativeTo(null);
	}
	public void setCurrentDir(String str){
		propertyPanel.setCurrentDir(str);
	}
	public void updateMode(LabeledNode lb){
		
		propertyPanel.setData(lb.getCreationCode(),lb.getId());
		this.setVisible(true);
	}
	public void insertMode(){
		
		propertyPanel.setObjectId("");
		this.setVisible(true);
	}
	public String getPropertyString(){
		return propertyPanel.getPropertyString();
	}
}


class BinderPopup extends JPopupMenu{
	public static final int JMENUITEMPOP_NEW = 0;
	public static final int JMENUITEMPOP_SEP0 = 1;
	public static final int JMENUITEMPOP_UNDO = 2;
	public static final int JMENUITEMPOP_REDO = 3;
	public static final int JMENUITEMPOP_SEP1 = 4;
	public static final int JMENUITEMPOP_CUT = 5;
	public static final int JMENUITEMPOP_COPY = 6;
	public static final int JMENUITEMPOP_PASTE = 7;
	public static final int JMENUITEMPOP_DELETE = 8;
	public static final int JMENUITEMPOP_SEP2 = 9;
	public static final int JMENUITEMPOP_GROUP = 10;
	public static final int JMENUITEMPOP_SELECTALL = 11;
	public static final int JMENUITEMPOP_SEP3 = 12;
	public static final int JMENUITEMPOP_PROPERTY = 13;
	public static final String[] JMENUITEMPOP__NAME = {"New","sep","Undo","Redo","sep","Cut","Copy","Paste","Delete","sep","Group","SelectAll"
	,"sep","Property"};
	public static final int[] JMENUITEMPOP__EVENT ={PPMainPanel.EVENT_NEW,-1,PPMainPanel.EVENT_UNDO,PPMainPanel.EVENT_REDO,-1,PPMainPanel.EVENT_CUT
	,PPMainPanel.EVENT_COPY,PPMainPanel.EVENT_PASTE,PPMainPanel.EVENT_DELETE,-1,PPMainPanel.EVENT_GROUP,PPMainPanel.EVENT_SELECTALL,-1,PPMainPanel.EVENT_SHOWPROPERTY};
	
	
	
	JMenuItem[] jMenuItemPop;
	BinderPopup(Hashtable<Object,Integer> eventObjectHash){
		
		
		jMenuItemPop = new JMenuItem[JMENUITEMPOP__NAME.length];
		for(int ii = 0;ii < JMENUITEMPOP__NAME.length;ii++){
			if(JMENUITEMPOP__NAME[ii].compareTo("sep") != 0){
				
				jMenuItemPop[ii] = new JMenuItem(JMENUITEMPOP__NAME[ii]);
				this.add(jMenuItemPop[ii]);
				if(JMENUITEMPOP__EVENT[ii] > -1){
					eventObjectHash.put(jMenuItemPop[ii],JMENUITEMPOP__EVENT[ii]);
				}
			}else{
				this.addSeparator();
			}
		}
		
	}
	public void addActionListener(ActionListener a){
		for(int ii = 0;ii < JMENUITEMPOP__NAME.length;ii++){
			
			if(JMENUITEMPOP__NAME[ii].compareTo("sep") != 0){
				jMenuItemPop[ii].addActionListener(a);
			}
		}
	}
	
	

}