import java.util.*;
import java.util.regex.*;
import java.io.*;

public class SimpleDataParser{
	
	
	public static Hashtable<String,String> loadSharpBlock(String filename){
		try{
			BufferedReader br = new BufferedReader(new FileReader(filename));
			String ln = null;
			ArrayList<String> al = new ArrayList<String>();
			while((ln = br.readLine()) != null){
				al.add(ln);
			}
			br.close();
			
			return loadSharpBlock(al);
			
		}catch(Exception exx){
			
			exx.printStackTrace();
		}
		return null;
	}
	
	public static Hashtable<String,String> loadSharpBlock(ArrayList<String> al){
		Pattern pat = Pattern.compile("^#(.+)[\r\n]*");
		Hashtable<String,String> ret = new Hashtable<String,String>();
		StringBuffer sb = new StringBuffer();
		String label = "";
		for(int ii = 0;ii < al.size();ii++){
			String ln = al.get(ii).replaceAll("[\r\n]+$","");
			if(ln.indexOf("#") == 0){
				//System.out.println(ln);
				if(label.length() > 0){
					ret.put(label,sb.toString().replaceAll("[\r\n]+$",""));
					sb = new StringBuffer();
				}
				label = "";
				Matcher mat = pat.matcher(ln);
				if(mat.find()){
					label = mat.group(1);
				}
			}else{
				
				sb.append(ln);
				sb.append("\n");
			}
		}
		
		if(label.length() > 0){
			ret.put(label,sb.toString().replaceAll("[\r\n]+$",""));
		}
		return ret;
	}
	
	
	
	
	public static void main(String[] args){
		Hashtable<String,String> hash = loadSharpBlock("test.dat");
		Enumeration<String> enu = hash.keys();
		while(enu.hasMoreElements()){
			String p = enu.nextElement();
			System.out.println("#"+p);
			System.out.println(hash.get(p));
		}
		
	}
}

